import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:lailao_bcel_qr/lailao_bcel_qr.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _qrCodeString = '';

  @override
  void initState() {
    super.initState();
    initQR();
  }

  Future<void> initQR() async {
    String qrCodeString;
    try {
      qrCodeString = LailaoBcelQr.bcelQr("XXXXXXXXXXX", "transactionId123",
          "terminalId123", 1, "invoiceId123");
    } on PlatformException {
      qrCodeString = 'Failed to get platform version.';
    }

    setState(() {
      _qrCodeString = qrCodeString;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Column(
          children: [
            const LailaoBcelQr(
              mcid: "XXXXXXXXXXX",
              amount: 1,
              invoiceId: 'iv123',
              terminalId: 'ti123',
              transactionId: 'tr123',
            ),
            Center(
              child: Text('ONEPAY CODE : $_qrCodeString\n'),
            ),
          ],
        ),
      ),
    );
  }
}
